<template>
  <div class="container centered">
    <h1>Bienvenue sur l'intranet</h1>
    <p>La plate-forme de l'entreprise</p>
    <hr>
    <h3>Avez-vous dit bonjour aujourd'hui à ...</h3>

    <Usercard :user="person" v-if="person" @remove="removeUser"/>

    <div class="actions">
      <a href="#" class="btn" @click.prevent="getRandomUser">
        <i class="fa fa-random"/> Dire bonjour à quelqu'un d'autre
      </a>
    </div>
  </div>
</template>

<script>
import Usercard from "./Usercard.vue";
import UserService from "../services/UserService.js";

export default {
  name: "Home",
  components: {
    Usercard
  },
  data: function() {
    return {
      people: null,
      person: null
    };
  },
  methods: {
    getRandomUser: function() {
      this.person = this.people[Math.floor(Math.random() * this.people.length)];
    },

    removeUser: function(userToDelete) {
      UserService.removeUser(userToDelete)
        .then(() => {
          let index = this.people.indexOf(userToDelete);
          if (index > -1) {
            this.people.splice(index, 1);
          }
          this.$toasted.success("Collaborateur supprimé ! 💪");
          this.getRandomUser();
        })
        .catch(({ message }) => this.$toasted.error(message));
    }
  },
  created: function() {
    UserService.fetchAll()
      .then(usersList => {
        this.people = usersList;
        this.getRandomUser();
      })
      .catch(({ message }) => this.$toasted.error(message));
  }
};
</script>

<style>
</style>
